MoveIt.GUI.Modules.Scale = {}

function MoveIt.GUI.Modules.Scale:Create(container)

	MoveIt.GUI.Modules:CreateEnabledCheckbox(container, "Scale", 0.3, "Scale")

	self.sliderMultiplier = AceGUI:Create("Slider")
	self.sliderMultiplier:SetLabel("Multiplier")
	self.sliderMultiplier:SetSliderValues(0.1, 10, 0.01)
	self.sliderMultiplier:SetRelativeWidth(0.7)
    self.sliderMultiplier:SetDisabled(true)
	self.sliderMultiplier:SetValue(1, false)
	self.sliderMultiplier:SetCallback("OnValueChanged", function() self:OnChangeSetting() end)
	container:AddChild(self.sliderMultiplier)

end

function MoveIt.GUI.Modules.Scale:OnChangeSetting()

    local modSettings = MoveIt:GetFrameSettings(MoveIt.GUI.Options.selectedFrame, "Scale")
    modSettings.Multiplier = self.sliderMultiplier:GetValue()
	MoveIt.Modules.Scale:Apply(MoveIt.GUI.Options.selectedFrame)

end

function MoveIt.GUI.Modules.Scale:Update(frameName)

	local modSettings = MoveIt:GetFrameSettings(frameName, "Scale")
    self.checkboxEnabled:SetValue(modSettings.Enabled)
    self.sliderMultiplier:SetValue(modSettings.Multiplier)

    self.checkboxEnabled:SetDisabled(false)
	self.sliderMultiplier:SetDisabled(not modSettings.Enabled)

end

function MoveIt.GUI.Modules.Scale:Disable()

	self.checkboxEnabled:SetValue(false, false)
    self.sliderMultiplier:SetValue(1, false)

    self.checkboxEnabled:SetDisabled(true)
	self.sliderMultiplier:SetDisabled(true)

end
